aboutsummaryrefslogtreecommitdiffstats
path: root/resources/libraries/bash/entry/tox/model_version.sh
diff options
context:
space:
mode:
authorVratko Polak <vrpolak@cisco.com>2022-01-31 15:24:53 +0100
committerPeter Mikus <peter.mikus@protonmail.ch>2022-06-30 07:02:06 +0000
commit9e22f65d5e9f7045625a8d6bf79ce75d836e1447 (patch)
tree847c04b2e7890700781289a62ab1a8b49c1ef3af /resources/libraries/bash/entry/tox/model_version.sh
parent325cef50672aed697e277405fe9bb9b797d02701 (diff)
style(tox): prepare for fixer scripts
The previous code assumes each tox script is a checker. We want to add fixer scripts (not voting but editing) soon. This is the less interesting part of the process, renaming things and updating comments. Includes some basic descriptions of how fixers differ from checkers. Change-Id: I1ca1572a328acd02b41dcf4e70d7cb3746a03b03 Signed-off-by: Vratko Polak <vrpolak@cisco.com>
Diffstat (limited to 'resources/libraries/bash/entry/tox/model_version.sh')
-rw-r--r--resources/libraries/bash/entry/tox/model_version.sh65
1 files changed, 65 insertions, 0 deletions
diff --git a/resources/libraries/bash/entry/tox/model_version.sh b/resources/libraries/bash/entry/tox/model_version.sh
new file mode 100644
index 0000000000..2bcc628bfb
--- /dev/null
+++ b/resources/libraries/bash/entry/tox/model_version.sh
@@ -0,0 +1,65 @@
+# Copyright (c) 2022 Cisco and/or its affiliates.
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at:
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+set -exuo pipefail
+
+# This file should be executed from tox, as the assumed working directory
+# is different from where this file is located.
+# This file does not have executable flag nor shebang,
+# to dissuade non-tox callers.
+
+# This script runs a two grep commands as "if" conditions,
+# using log files to store the data (generated by git commands) to grep,
+# failing when model implementation edits do not come with model version edit.
+# The contents of the log files may be useful when fail cause is not obvious.
+
+# "set -eu" handles failures from the following two lines.
+BASH_CHECKS_DIR="$(dirname $(readlink -e "${BASH_SOURCE[0]}"))"
+BASH_FUNCTION_DIR="$(readlink -e "${BASH_CHECKS_DIR}/../../function")"
+source "${BASH_FUNCTION_DIR}/common.sh" || {
+ echo "Source failed." >&2
+ exit 1
+}
+
+impl_log="edited_files.log"
+git diff --name-only HEAD~ > "${impl_log}"
+if ! grep -q '^docs/model/current/schema/test_case*' "${impl_log}"; then
+ # Failing grep means no model edits.
+ warn "No model implementation edits detected."
+ warn
+ warn "CSIT model version checker: PASS"
+ exit 0
+fi
+const_log="constants_edits.log"
+git diff -U0 HEAD~ -- "resources/libraries/python/Constants.py" > "${const_log}"
+if ! grep -q '^\+ MODEL_VERSION = ' "${const_log}"; then
+ warn "Model implementation edits without version edit detected!"
+ warn "See ${impl_log} and ${const_log} for what was detected."
+ warn
+ warn "CSIT model version checker: FAIL"
+ exit 1
+fi
+doc_log="docs_edits.log"
+git diff -U0 HEAD~ -- "docs/model/current/top.rst" > "${doc_log}"
+if ! grep -q '^\+This document is valid for CSIT model' "${doc_log}"; then
+ warn "Model implementation edits without documentation update detected!"
+ warn "See ${impl_log}, ${const_log} and ${doc_log} for what was detected."
+ warn
+ warn "CSIT model version checker: FAIL"
+ exit 1
+fi
+# TODO: Check constants and docs are specifying the same version.
+warn "Model version and doc are edited, model implementation edits are allowed."
+warn
+warn "CSIT model version checker: PASS"
+exit 0